// --------------------------------------------------------
// Code generated by Papyrus C++
// --------------------------------------------------------

#define Mult_clientCompdef_Mult_client_impl_BODY

/************************************************************
 Mult_client_impl class body
 ************************************************************/

// include associated header file
#include "Mult_clientCompdef/Mult_client_impl.h"

// Derived includes directives
#include "rclcpp/rclcpp.hpp"

namespace Mult_clientCompdef {

// static attributes (if any)
short int xval=1;
short int yval=1;

/**
 * 
 * @param options 
 */
Mult_client_impl::Mult_client_impl(rclcpp::NodeOptions /*in*/options) :
		Mult_client(options) {
}

/**
 * 
 */
void Mult_client_impl::mainClientFunction() {
	//std::cout << "cyclic execution of main client function" << std::endl;
	xval += 2;
	yval += 1;

	auto request = std::make_shared<fromscratch_services::srv::QueryMultInMultOut::Request>();
	request->xval = xval;
	request->yval = yval;

	multiply_client_->async_send_request(request,
			[this](
					rclcpp::Client<fromscratch_services::srv::QueryMultInMultOut>::SharedFuture arg_future) {
				auto response = arg_future.get();
				RCLCPP_INFO(get_logger(), "result = %d", response->result);
			}
	);	
}

/**
 * 
 * @param numofrequests 
 */
void Mult_client_impl::processed_requests_handler(
		const fromscratch_services::msg::NumOfRequests::SharedPtr /*in*/numofrequests) {
	std::cout << "got numofrequests" << std::endl;
	std::cout << "nb: " << numofrequests->value << std::endl;
}

} // of namespace Mult_clientCompdef

/************************************************************
 End of Mult_client_impl class body
 ************************************************************/
